﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using UnityEngine.Events;
using MVR.FileManagementSecure;

// VaM Rotator Plugin by Captain Varghoss
//
// Simple plugin to enable rotation on XYZ axis with variable speed and direction.
//
// Version 2
// Fixed bug with reverse toggle trigger not working.

namespace ParticlePinnacle {
	public class movement : MVRScript {

		private Atom _atom;
		//targets
		private static Atom person2;
		private static Atom currentAtom;
		protected JSONStorableStringChooser uiFocusTarget;
		protected JSONStorableStringChooser uiAnimationSets;
		private static string currentAtomName = "None";
		 private static FreeControllerV3 playerTipController;
		private static bool isObject = false;
		private FreeControllerV3 freeController;
		private JSONStorableBool moveToTarget; //synth
		public Vector3 goal = new Vector3(0, 0, 0);
        public Collider groundCollider;
		private static float velocityforsmoothdamp=0f;
        Vector3 lastPosition;
        Vector3 lastEuler;
		Transform goalMarker;
		Transform tempgoalMarker;
		Transform tempgoalMarker2;
		JSONStorableBool showTarget;
		//end synth vars
		//macgruber stuff
		private JSONStorableBool myAcceptTrigger;
		private EventTrigger WalkAnimActions;
		private EventTrigger IdleAnimActions;
		private EventTrigger BackAnimActions;
		private EventTrigger RightAnimActions;
		private EventTrigger LeftAnimActions;
		//public float[] EnergyArray = new float[700];
		public float[] deltatimearray = new float[700];
		public float[] SlowdownVelocityArray = new float[500];
		private JSONStorableBool isActive;
		private JSONStorableBool FollowToggle;
		private JSONStorableBool AutoMoveBack;
		private JSONStorableBool UseRightController;
		private JSONStorableBool UseLeftController;
		private JSONStorableString helpText;
		//private JSONStorableString stateInfos;
		protected JSONStorableFloat setModelX;
		protected JSONStorableFloat setModelY;
		protected JSONStorableFloat setModelZ;
		protected JSONStorableFloat setModelYRot;
		protected JSONStorableFloat ForwardGoalVelocity;
		protected JSONStorableFloat ModelAcceleration;
		protected JSONStorableFloat VelocityDeadzone;
		protected JSONStorableFloat ModelDecelleration;
		protected JSONStorableFloat AlignmentDistance;
		protected JSONStorableFloat followdistance;
		protected JSONStorableFloat smoothTime;
		protected JSONStorableFloat movebackdistance;
		protected JSONStorableFloat LeftRightAcceleration;
		protected JSONStorableFloat ControllerTriggerSensitivity;
		protected JSONStorableFloat AnimationNumberSelector;
		protected JSONStorableFloat AnimationSpeedMult;
		protected JSONStorableFloat RotationSpeed;
		private static float globaltimer1=0f; 
		private static float VelocityForward=0f; 
		private static float VelocityBackward=0f; 
		private static float VelocityLeft=0f; 
		private static float VelocityRight=0f; 
		private static float ModelEnergy=0f; 
		private static float tempVelocity=0f; 
		private static float following=0f; 
		private static float DebugTimer=0f; 
		private static float SlowDownDistance=0f;
		private static float backtimer=0f;
		private static float RightTimer=0f;
		private static float LeftTimer=0f;
		private static float currentXPositionPlayer=0f;
		private static float currentZPositionPlayer=0f;
		private static float DebugAlignTimer=5f;
		
		private static float PastPlayerXPosition=0f;
		private static float PastPlayerZPosition=0f;
	
		private static float currentXPosition=0f;
		private static float currentYPosition=0f;
		private static float currentZPosition=0f;
		private static int SlowDown=0;
		private static int MoveForward=0;
		private static int MoveBackward=0;
		private static int MoveRight=0;
		private static int MoveLeft=0;
		private static int TriggerWalkAnimActionsOnce=0;
		private static int TriggerIdleAnimActionsOnce=0;
		private static int TriggerBackAnimActionsOnce=0;
		private static int TriggerWalkBackAnimActionsOnce=0;
		private static int TriggerMoveLeftAnimActionsOnce=0;
		private static int TriggerMoveRightAnimActionsOnce=0;
		private static int DebugAlign=0;
		private static int AnimationSet=1;
		private static int DoNotTryTimeline=0;
		private static int check=0;
		private static int ForwardCheck=0;
		private static int BackwardCheck=0;
		private static int genericAtom=0;
		List<string> storableIDs;
		List<string> matchingIDs;
		//public var go;
		private static float distance=0f;
		private static float BoxThing=0f;
		private static float AverageDeltaTime=0f;
		public string targetID;
		JSONStorable Timeline;
		//private static float tempgoalMarker=0f;
		//private static float tempgoalMarker2=0f;
		
		

		public override void Init() {
			try {
				// Grab Containing Atom
				_atom = containingAtom;
				//List<string> storableIDs =_atom.GetStorableIDs();
				//string targetID="timeline";
				
				// Retrieve IDs from the Atom object
				
			storableIDs = _atom.GetStorableIDs();

			// Search for the desired ID
			
			string targetIDsub = "VamTimeline.AtomPlugin";
			
			matchingIDs = GetStorableIDsContainingSubstring(targetIDsub);
			
			if (matchingIDs != null && matchingIDs.Count > 0)
        {
				targetID = matchingIDs[0]; // This could be the ID you are looking for
		}
			if (storableIDs.Contains(targetID))
			{
				// Call the JSONStorable using the found ID
				
				Timeline = _atom.GetStorableByID(targetID) as JSONStorable;
				
				//SuperController.LogMessage("storable id " +Timeline);
            // Check if the Timeline is not null and is of the JSONStorable type
				if (Timeline != null)
				{
					SuperController.LogMessage("timeline default anim names enabled" );
				}
				else
				{
					DoNotTryTimeline=1;
					SuperController.LogMessage("timeline not detected" );
				}
			}
				//right and left controller stuff
				//right controller
				UseRightController = new JSONStorableBool ("Use Right Controller", true);
				RegisterBool (UseRightController);
				CreateToggle(UseRightController,true);
				
				JSONStorableAction UseRightControlleryy = new JSONStorableAction("Toggle right controller", () =>
                {
                    UseRightController.val = !UseRightController.val;
					
                });
				RegisterAction(UseRightControlleryy);
				//left controller
				UseLeftController = new JSONStorableBool ("Use Left Controller", false);
				RegisterBool (UseLeftController);
				CreateToggle(UseLeftController);
				
				JSONStorableAction UseLeftControlleryy = new JSONStorableAction("Toggle Left controller", () =>
                {
                    UseLeftController.val = !UseLeftController.val;
					
                });
				RegisterAction(UseLeftControlleryy);
				//end controllers
				
				FollowToggle = new JSONStorableBool ("Following", true);
				RegisterBool(FollowToggle);
				CreateToggle(FollowToggle);
				
				JSONStorableAction FollowToggleyy = new JSONStorableAction("Toggle Follow", () =>
                {
                    FollowToggle.val = !FollowToggle.val;
					
                });
				RegisterAction(FollowToggleyy);
				
				//AutoMoveBack
				AutoMoveBack = new JSONStorableBool ("Auto Moveback", false);
				RegisterBool(AutoMoveBack);
				CreateToggle(AutoMoveBack);
				
				JSONStorableAction AutoMoveBackyy = new JSONStorableAction("Toggle AutoMoveBack", () =>
                {
                    AutoMoveBack.val = !AutoMoveBack.val;
					
                });
				RegisterAction(AutoMoveBackyy);
				
				moveToTarget = new JSONStorableBool("Controller Input", false);//synth stuff
                RegisterBool(moveToTarget);
                CreateToggle(moveToTarget, true);
				
				JSONStorableAction moveToTargetyy = new JSONStorableAction("Toggle UserInput", () =>
                {
                    moveToTarget.val = !moveToTarget.val;
					
                });
				RegisterAction(moveToTargetyy);
				
				showTarget = new JSONStorableBool("show target", false, SetTargetVisibility);
                RegisterBool(showTarget);
                CreateToggle(showTarget, true);
				goalMarker= CreateMarker(containingAtom.transform);
				//macgruber load?
				SimpleTriggerHandler.LoadAssets();
					AlignmentDistance = new JSONStorableFloat("Alignment Distance", .8f, 0f, 3f, true, true);
				RegisterFloat(AlignmentDistance);
				CreateSlider(AlignmentDistance, false);
				followdistance = new JSONStorableFloat("follow distance", 1.55f, 1.1f, 5f, true, true);
				RegisterFloat(followdistance);
				CreateSlider(followdistance, false);
				movebackdistance = new JSONStorableFloat("move back distance", .42f, .25f, 3f, true, true);
				RegisterFloat(movebackdistance);
				CreateSlider(movebackdistance, false);
				smoothTime = new JSONStorableFloat("Alignment Time", .3f, .01f, 1f, true, true);
				RegisterFloat(smoothTime);
				CreateSlider(smoothTime, false);
				/* WalkAnimActions = new EventTrigger(this, "OnTrigger");
				Utils.SetupButton(this, "Point to Walk", WalkAnimActions.OpenPanel, true); 
				IdleAnimActions = new EventTrigger(this, "OnTrigger");
				Utils.SetupButton(this, "Point to Idle", IdleAnimActions.OpenPanel, true);
				BackAnimActions = new EventTrigger(this, "OnTrigger");
				Utils.SetupButton(this, "Point to backward", BackAnimActions.OpenPanel, true);
				LeftAnimActions = new EventTrigger(this, "OnTrigger");
				Utils.SetupButton(this, "Point to Move Left", LeftAnimActions.OpenPanel, true); //went in a different direction, since these are really painful to do building a scene
				RightAnimActions = new EventTrigger(this, "OnTrigger");
				Utils.SetupButton(this, "Point to Move Right", RightAnimActions.OpenPanel, true); */
 
			//shortcuts!
								
				var SetToBasis = CreateButton("Set to Basis", false);
                SetToBasis.button.onClick.AddListener(() => { SetToBasisRun(); });
				
				var TestRight = CreateButton("TestRight", false);
                TestRight.button.onClick.AddListener(() => { TestRightRun(); });
				
				var action1 = new JSONStorableAction("Move Right", TestRightRun);
				this.RegisterAction(action1);
				
				
				var TestLeft = CreateButton("Move Left", false);
                TestLeft.button.onClick.AddListener(() => { TestLeftRun(); });
				
				var action2 = new JSONStorableAction("Move Left", TestLeftRun);
				this.RegisterAction(action2);
				
				
				var DebugAlignSub = CreateButton("DebugAlignSub", false);
                DebugAlignSub.button.onClick.AddListener(() => { DebugAlignSubRun(); });
				
				var action3 = new JSONStorableAction("Align", DebugAlignSubRun);
				this.RegisterAction(action3);
				
				var action4 = new JSONStorableAction("Move Back", MoveBack);
				this.RegisterAction(action4);
				
				List<string> targetChoices = new List<string>();
				foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
				{
					currentAtom = SuperController.singleton.GetAtomByUid(atomUID);
					if (currentAtom != containingAtom && atomUID != null)
					{
						targetChoices.Add(atomUID);
					}
				}
				uiFocusTarget = new JSONStorableStringChooser("Follow This", targetChoices, "PlayerNavigationPanel", "Choose Person");
				RegisterStringChooser(uiFocusTarget);
				UIDynamicPopup udp = CreateScrollablePopup(uiFocusTarget, true);
				
				List<string> AnimationSets = new List<string>();
				AnimationSets.Add("1");
				AnimationSets.Add("2");
				AnimationSets.Add("3");
				AnimationSets.Add("4");
				AnimationSets.Add("5");
				AnimationSets.Add("6");
				AnimationSets.Add("7");
				AnimationSets.Add("8");
				AnimationSets.Add("9");
				AnimationSets.Add("10");
				AnimationSets.Add("11");
				AnimationSets.Add("12");
				uiAnimationSets = new JSONStorableStringChooser("Animation Set", AnimationSets, "1", "Animation Set");
				RegisterStringChooser(uiAnimationSets);
				UIDynamicPopup udpy = CreateScrollablePopup(uiAnimationSets, true); 
				JSONStorableString headerBox2 = new JSONStorableString("Header","Checkboxes to use alternates");
				UIDynamic headerBoxField2 = CreateTextField(headerBox2, true);
				headerBoxField2.height =20f;
				ControllerTriggerSensitivity = new JSONStorableFloat("Trigger Sensitivity", .99f, 0f, 1f, true, true);
				RegisterFloat(ControllerTriggerSensitivity);
				CreateSlider(ControllerTriggerSensitivity, true);
				
				JSONStorableString headerBox = new JSONStorableString("Header","\n<b>Game Logic</b>\n read help below");
				UIDynamic headerBoxField = CreateTextField(headerBox, false);
				headerBoxField.height = 100f;
				setModelX = new JSONStorableFloat("Set Model Base X", 0f, -4f, 4.0f, true, true);
				RegisterFloat(setModelX);
				CreateSlider(setModelX, false);
				setModelY = new JSONStorableFloat("Set Model Base Y", 0f, -4f, 4.0f, true, true);
				RegisterFloat(setModelY);
				CreateSlider(setModelY, false);
				setModelZ = new JSONStorableFloat("Set Model Base Z", 0f,-4f, 4.0f, true, true);
				RegisterFloat(setModelZ);
				CreateSlider(setModelZ, false);
				//AnimationNumberSelector = new JSONStorableFloat("AnimationNumberSelector", 1f, 1f, 3f, true, true);
				//RegisterFloat(AnimationNumberSelector);
				//CreateSlider(AnimationNumberSelector, true);
				AnimationSpeedMult = new JSONStorableFloat("AnimationSpeedMult", 1f, 1f, 3f, true, true);
				RegisterFloat(AnimationSpeedMult);
				CreateSlider(AnimationSpeedMult, true);
				setModelYRot = new JSONStorableFloat("Set Model Base Rotation", 0f, -360f, 360f, true, true);
				RegisterFloat(setModelYRot);
				CreateSlider(setModelYRot, false);
				VelocityDeadzone = new JSONStorableFloat("VelocityDeadzone", .1f, 0f, .3f, true, true);
				RegisterFloat(VelocityDeadzone);
				CreateSlider(VelocityDeadzone, false);
				ForwardGoalVelocity = new JSONStorableFloat("Forward Goal Velocity", 1f, 0f, 3f, true, true);
				RegisterFloat(ForwardGoalVelocity);
				CreateSlider(ForwardGoalVelocity, false);
				ModelAcceleration = new JSONStorableFloat("Model Acceleration", .3f, 0f, 50f, true, true);
				RegisterFloat(ModelAcceleration);
				CreateSlider(ModelAcceleration, false);
				ModelDecelleration = new JSONStorableFloat("Model Back/Decelleration", .3f, 0f, 50f, true, true);
				RegisterFloat(ModelDecelleration);
				CreateSlider(ModelDecelleration, false);
				LeftRightAcceleration = new JSONStorableFloat("Left Right Acceleration", .4f, 0f, 3f, true, true);
				RegisterFloat(LeftRightAcceleration);
				CreateSlider(LeftRightAcceleration, false);
				RotationSpeed = new JSONStorableFloat("RotationSpeed", 1.5f, 0f, 5f, true, true);
				RegisterFloat(RotationSpeed);
				CreateSlider(RotationSpeed, true);
				//ModelMass = new JSONStorableFloat("Model Mass", 60f, 30f, 200f, true, true);
				//RegisterFloat(ModelMass);
				//CreateSlider(ModelMass, false);
				//VaMRotatorBuildUI();

				helpText = new JSONStorableString("Helptext", "\n\nTerrible attempt at movement.\n\nMovement can be controlled by either having Follow set to on and selecting"+
				" an Atom in\nthe drop down menu\n or alternatively checking follow and move to target\n check which controller you want to use and maybe adjust the sensitivity"+
				" no need to point to animations if you have a single instance of timeline running on a model the plugin can find them if you follow the naming &animation scheme=>\n\n "+
				"on stop animations can't be a loop unfortunately, you'll need to have a really long one or have your on stop animation go to another animation which sends it back to the original"+
				" in the sequencer\nName model's animation cycles\nwalk 1, walk 2, walk 3\non stop 1,   on stop 2,   on stop 3\nback 1, back 2, back 3\nright 1,  right 2,  right 3\nleft 1,     left 2,     left 3"+
				"\n^^up to 12 set of animations are optional\n If you want two atoms to interact i.e. play an animation they need to be aligned, i would reccommend triggering externally if movement is "+
				"on both atoms, just have them pointed at eachother in the following box and trigger alignment on one model/atom\n\n Other info on sliders, Model Acceleration affects how fast the model moves fast, Forward goal velocity is your capped velocity, animation selector will set animations of movement to their different values, they'll only change if you change direction(forward to backward, left to right, left to forward, etc. Velocity Deadzone is how slow the model needs to move to do the on stop animation, or how fast you need to be to break into another animation");
				UIDynamic helpTextfield = CreateTextField(helpText, false);
				helpTextfield.height = 700f;
				
				//stateInfos = new JSONStorableString("Stateinfos", "");
//				UIDynamic stateinfosTextfield = CreateTextField(stateInfos, true);
//				stateinfosTextfield.height = 380.0f;
				
				SuperController.LogMessage("Movement Loaded on: " +_atom.name);
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		/* void VaMRotatorBuildUI() {

		}
		
		void VaMRotatorDestroyUI() {
			
		}
 */
		/* void VaMRotatorRebuildUI(bool arg) {
			VaMRotatorDestroyUI();
			VaMRotatorBuildUI();
		}
 */
		// Update is called with each rendered frame by Unity
		void Update() {
			//try {
				var playerPositionController=_atom.GetStorableByID("control");
				
				//get person
				currentAtomName = uiFocusTarget.val;
				if (_atom.type == "Person")
					{
						currentXPosition = transform.position.x;
						currentYPosition = transform.position.y;
						currentZPosition = transform.position.z;
						genericAtom=0;
					}
				else
				{
					Transform objectTransform = containingAtom.transform;
					Vector3 localPosition = objectTransform.localPosition;
					currentXPosition = localPosition.x;
					currentYPosition = localPosition.y;
					currentZPosition = localPosition.z;
					genericAtom=1;
				} 
				if (FollowToggle.val==true);//((person2 == null || playerPositionController == null) && currentAtomName != "None")
				{
					person2 = SuperController.singleton.GetAtomByUid(uiFocusTarget.val);
					if (person2 == null)
					{
						uiFocusTarget.val = "None";
						currentAtomName = "None";
					}
					else
					{
						if (person2.type == "Person")
						{
							isObject = false;
							//toyFloat = 0.0f;
							playerPositionController = person2.GetStorableByID("control");
							
						}
						else
						{
							isObject = true;
							//toyFloat = uiToyMulti.val;
							playerPositionController = person2.GetStorableByID("control");
						}
				}}
				//if goal is the target!
				if (moveToTarget.val==true);//((person2 == null || playerPositionController == null) && currentAtomName != "None")
				{
					if (person2 == null)
					{
						uiFocusTarget.val = "None";
						currentAtomName = "None";
					}
				}
				//idiot checks
				if(AlignmentDistance.val>followdistance.val){
					AlignmentDistance.val=followdistance.val-.05f;
				}
				if(movebackdistance.val>AlignmentDistance.val){
					movebackdistance.val=AlignmentDistance.val-.05f;
				}
				
				//AnimationSet=(int)Mathf.Round(AnimationNumberSelector.val);
			
				// end goal to target
			/* 	if (_atom.type == "Person")
					{
						currentXPosition = transform.position.x;
						currentYPosition = transform.position.y;
						currentZPosition = transform.position.z;
					} */
				
					
				Quaternion currentRotation = transform.rotation;
				// Convert the rotation to Euler angles for easier understanding
				Vector3 eulerRotation = currentRotation.eulerAngles;

				float currentXRotation =  eulerRotation.x;
				float currentYRotation =  eulerRotation.y;
				float currentZRotation =  eulerRotation.z;
				
				var atomControl = _atom.GetStorableByID("control");//as FreeControllerV3;
				if(FollowToggle.val==true){
				currentXPositionPlayer = playerPositionController.transform.position.x;
				currentZPositionPlayer = playerPositionController.transform.position.z;
				}
				if(moveToTarget.val==true){
				currentXPositionPlayer = goal.x;
				currentZPositionPlayer = goal.z;
				}
				
				//increment globaltimer1 for debug
				if(globaltimer1>0f)
					globaltimer1+=Time.deltaTime;
				//safety switch
				if(globaltimer1>6f)
				{
					globaltimer1=0f;
					MoveForward=0;
				}
				//more synth stuff
				if (moveToTarget.val)
				{
					MovementInput();
					goalMarker.transform.position = goal;
				}
				else
				{
					SetTargetVisibility(false);
				}
				//end more synth stuff
				
				if (FollowToggle.val==true)
				{
					//get person/object control
					
					var Person2atomControl = person2.GetStorableByID("control");
					
					 // Calculate the direction towards the target
					
					Vector3 directionToTarget = Person2atomControl.transform.position-atomControl.transform.position;
					directionToTarget.y=0f;
					
					Quaternion targetRotation = Quaternion.LookRotation(directionToTarget);

					// Smoothly interpolate towards the target rotation using SLERP
					atomControl.transform.rotation = Quaternion.Slerp(transform.rotation, targetRotation, RotationSpeed.val * Time.deltaTime);
					
				if (Person2atomControl != null && atomControl != null)
				{
					// Calculate the distance between atom1 and atom2
					Vector3 position1 = Person2atomControl.transform.position;
					if(genericAtom<1){						
					Vector3 position2 = atomControl.transform.position;
					position1.y = position2.y;
					distance = Vector3.Distance(position1, position2);
					}
					if(genericAtom>0){
					Transform objectTransform = _atom.transform;
					Vector3 position2 = atomControl.transform.localPosition;
					position1.y = position2.y;
					objectTransform.localPosition = position1;
					distance = Vector3.Distance(position1, objectTransform.localPosition);
					}

					// Ignore the Y-coordinate by setting it to the same value for both positions
					

					// Calculate the distance between the modified positions
					
				}
				} 
				//for walking to target
				if (moveToTarget.val==true)
				{
					//get person/object control
					//var Person2atomControl = person2.GetStorableByID("control");
					//Vector3 target = playerPositionController;
					 // Calculate the direction towards the target
					//freeController = GetComponent<playerPositionController>();
					Vector3 directionToTarget = goal-atomControl.transform.position;
					directionToTarget.y=0f;
					// Create a rotation towards the target
					Quaternion targetRotation = Quaternion.LookRotation(directionToTarget);

					// Smoothly interpolate towards the target rotation using SLERP
					atomControl.transform.rotation = Quaternion.Slerp(transform.rotation, targetRotation, RotationSpeed.val * Time.deltaTime);
					
				
					// Calculate the distance between atom1 and atom2
					Vector3 position1 = goal;
					Vector3 position2 = atomControl.transform.position;

					// Ignore the Y-coordinate by setting it to the same value for both positions
					position1.y = position2.y;

					// Calculate the distance between the modified positions
					distance = Vector3.Distance(position1, position2);
					
				} 
				//get average delta time
				float sum=0f;
				for (int i = deltatimearray.Length-1; i >0 ; i--)
					{
							deltatimearray[i]=deltatimearray[i-1];// if you're looking at this, the previous version of shifting just copied the [1] position over everything, my b
						
					}
				deltatimearray[0]=Time.deltaTime;
				for (int i = deltatimearray.Length-1; i >-1 ; i--)
					{
						sum = sum+deltatimearray[i];
					}

        // Calculate the average value
				AverageDeltaTime = sum / deltatimearray.Length;
				
				
				//keep adding energy until goal is reached
				if(ForwardGoalVelocity.val>VelocityForward && MoveForward>0)
				{
					VelocityForward +=ModelAcceleration.val*Time.deltaTime;
					
				}
				if(FollowToggle.val==true && distance >followdistance.val&&DebugAlign<1)
					{
						MoveForward=1;
					}
					
				//calculate slowdown distance
				//SlowDownDistance=-5f;
				
				//slow down overshoot detected or model has moved into moveback(safety) distance
			
				if(distance<AlignmentDistance.val+.5f&&MoveForward>0){
					MoveForward=0;
					ForwardCheck=0;
					velocityforsmoothdamp=0f;
					
				}
				
				//then this for precision
				if(distance<AlignmentDistance.val+.5f&&MoveForward<1&&ForwardCheck<1){
										
					//VelocityForward=(distance-AlignmentDistance.val);//not sure how this works, but it does
					//trying smoothdamp
					//
					float ThisNewDistance = Mathf.SmoothDamp(distance, AlignmentDistance.val, ref velocityforsmoothdamp, smoothTime.val);
					VelocityForward=-velocityforsmoothdamp;//(distance-ThisNewDistance)/Time.deltaTime;
					
					 if(distance<1.05f*AlignmentDistance.val&&ForwardCheck<1&&DebugAlign<1){
						DebugAlign=1;
						VelocityForward=0f;
						ForwardCheck=1;
						PastPlayerXPosition=currentXPositionPlayer;
						PastPlayerZPosition=currentZPositionPlayer;
						
					} 
				}
				 if(distance < movebackdistance.val&&AutoMoveBack.val==true)
				{
					MoveBackward=1;
					backtimer=.001f;
					BackwardCheck=0;
				}  

				//move back to alignment distance
			 	if(MoveBackward>0&&backtimer<5f&&BackwardCheck<1)
				{
					float ThisNewDistance = Mathf.SmoothDamp(distance, AlignmentDistance.val, ref velocityforsmoothdamp, smoothTime.val);
					VelocityBackward=-velocityforsmoothdamp/10f;
					if(VelocityBackward<-ForwardGoalVelocity.val/10f){
						VelocityBackward=(-ForwardGoalVelocity.val)/10f;//so model doesn't just move straight back to infinity
					}
					/*  if(distance>.90f*AlignmentDistance.val){
						VelocityBackward=0f;
						BackwardCheck=1;
						DebugAlign=1;
						PastPlayerXPosition=currentXPositionPlayer;
						PastPlayerZPosition=currentZPositionPlayer;
						
					}  */
					//MoveForward=0;
				}    
				
				if(MoveRight>0){
					RightTimer+=Time.deltaTime;
					if(RightTimer<=1f){
						VelocityRight+=LeftRightAcceleration.val*AverageDeltaTime;
					}
					if(RightTimer>1f)
					{
						VelocityRight-=LeftRightAcceleration.val*AverageDeltaTime;
					}
					if((VelocityRight)<0f){
						VelocityRight=0f;
						ResetMovement();
					}
				}
				if(MoveLeft>0){
					LeftTimer+=Time.deltaTime;
					if(LeftTimer<=1f){
						VelocityLeft+=LeftRightAcceleration.val*AverageDeltaTime;
					}
					if(LeftTimer>1f)
					{
						VelocityLeft-=LeftRightAcceleration.val*AverageDeltaTime;
					}
					if((VelocityLeft)<0f){
						VelocityLeft=0f;
						ResetMovement();
					}
				}
				//debugging block
				if(DebugTimer<.1f)
					{
						DebugTimer+=Time.deltaTime;
					}
				else
					{	
					DebugTimer=0f;
					}   
				//debugging block	
				float VelocityTotalBackForward=VelocityForward+VelocityBackward; 
				//forward/backward movement
				float Xsin=Mathf.Sin(currentYRotation*0.017453f)*( VelocityTotalBackForward*Time.deltaTime)+Mathf.Sin((currentYRotation*0.017453f+3.1457f/2f))*(VelocityRight-VelocityLeft)*Time.deltaTime;
				float Zcos=Mathf.Cos(currentYRotation*0.017453f)*( VelocityTotalBackForward*Time.deltaTime)+Mathf.Cos((currentYRotation*0.017453f+3.1457f/2f))*(VelocityRight-VelocityLeft)*Time.deltaTime;
				
				
				if(DebugAlign<1&&FollowToggle.val==true&&genericAtom<1)
				{
					atomControl.transform.position = new Vector3(currentXPosition+Xsin, currentYPosition, currentZPosition+Zcos) ;
				} 
				//Transform objectTransform = _atom.transform;
				if(DebugAlign<1&&FollowToggle.val==true&&genericAtom>0)
				{
					//Transform objectTransform = _atom.transform;
					//objectTransform.transform.position = new Vector3(currentXPosition+Xsin, currentYPosition, currentZPosition+Zcos) ;
				}  
				//keep debug align from continuing to trigger during target changes, why would you?
				if(PastPlayerXPosition!=currentXPositionPlayer||PastPlayerZPosition!=currentZPositionPlayer||moveToTarget.val==true){
						DebugAlign=0;
					}
				//float distancevsalignmentdistance=(distance*19f+AlignmentDistance.val)/20f;
				if(DebugAlign>0&&FollowToggle.val==true)
				{
					if(genericAtom<1){
					ResetMovement();
					VelocityForward=0f;
					VelocityBackward=0f;
					VelocityLeft=0f;
					VelocityRight=0f;
					}
					
					//check for target switch and also distance change... align cannot be used if either value is changed from its start
					
					if(distance!=AlignmentDistance.val)
					{
						
						float currentDistance = Mathf.SmoothDamp(distance, AlignmentDistance.val, ref velocityforsmoothdamp, smoothTime.val);
						if(genericAtom<1){
						atomControl.transform.position = new Vector3(currentXPositionPlayer+Mathf.Sin(currentYRotation*0.017453f-3.14159f)*currentDistance, currentYPosition, currentZPositionPlayer+Mathf.Cos(currentYRotation*0.017453f-3.14159f)*currentDistance) ;
						//SuperController.LogMessage("DebugAlign" + DebugAlign);
						}
						if(genericAtom>0){
							//Transform objectTransform = _atom.transform;
							//objectTransform.transform.position = new Vector3(currentXPositionPlayer+Mathf.Sin(currentYRotation*0.017453f-3.14159f)*currentDistance, currentYPosition, currentZPositionPlayer+Mathf.Cos(currentYRotation*0.017453f-3.14159f)*currentDistance) ;
						}
					//atomControl.transform.position = new Vector3(currentXPositionPlayer+Mathf.Sin(currentYRotation*0.017453f-3.14159f)*AlignmentDistance.val, currentYPosition, currentZPositionPlayer+Mathf.Cos(currentYRotation*0.017453f-3.14159f)*AlignmentDistance.val) ;
					}
					if(distance<AlignmentDistance.val*1.0001f&&distance>AlignmentDistance.val*.9999f)
					{
						DebugAlign=0;
						
					}
				}
				
				CheckMovementPlayAnim();
				//AnimationSpeedChanger();
			//}
			  /*  catch (Exception e) {
				 SuperController.LogError("Exception caught: " + e);
				 
			 }  */
			 
		}
		private void CheckMovementPlayAnim()
		{
			float maxleftright=Mathf.Max(Mathf.Abs(VelocityLeft),Mathf.Abs(VelocityRight));
			float VelocityTotalBackForward=VelocityForward+VelocityBackward; 
			//walk
			if(DoNotTryTimeline<1){
			 if(Mathf.Abs(VelocityTotalBackForward)>VelocityDeadzone.val&&Mathf.Abs(VelocityTotalBackForward)>Mathf.Abs(maxleftright)&&VelocityTotalBackForward>0f&&TriggerWalkAnimActionsOnce<1)
			{
				ResetAnimOnces();
				TriggerWalkAnimActionsOnce=1;
				//BackAnimActions.Trigger();
				
				Timeline.CallAction("Play walk "+uiAnimationSets.val);
				
			} 
			//back
			if(VelocityBackward<-VelocityDeadzone.val&&Mathf.Abs(VelocityBackward)>Mathf.Abs(maxleftright)&&VelocityTotalBackForward<0f&&TriggerBackAnimActionsOnce<1)
			{
				ResetAnimOnces();
				TriggerBackAnimActionsOnce=1;
				//BackAnimActions.Trigger();
				Timeline.CallAction("Play back "+uiAnimationSets.val);
			}
			//idle
			if(Mathf.Abs(VelocityTotalBackForward)<VelocityDeadzone.val&&maxleftright<VelocityDeadzone.val&&TriggerIdleAnimActionsOnce<1)
			{
				ResetAnimOnces();
				TriggerIdleAnimActionsOnce=1;
				//IdleAnimActions.Trigger();
				Timeline.CallAction("Play on stop "+uiAnimationSets.val);
			}
			//right
			if(Mathf.Abs(VelocityRight)>VelocityDeadzone.val&&Mathf.Abs(VelocityRight)>Mathf.Abs(VelocityForward)&&Mathf.Abs(VelocityLeft)<Mathf.Abs(VelocityRight)&&TriggerMoveRightAnimActionsOnce<1)
			{
				ResetAnimOnces();
				TriggerMoveRightAnimActionsOnce=1;
				
				//RightAnimActions.Trigger();
				Timeline.CallAction("Play right "+uiAnimationSets.val);
			}
			//left
			if(Mathf.Abs(VelocityLeft)>VelocityDeadzone.val&&Mathf.Abs(VelocityLeft)>Mathf.Abs(VelocityForward)&&Mathf.Abs(VelocityLeft)>Mathf.Abs(VelocityRight)&&TriggerMoveLeftAnimActionsOnce<1)
			{
				ResetAnimOnces();
				TriggerMoveLeftAnimActionsOnce=1;
				//LeftAnimActions.Trigger();
				Timeline.CallAction("Play left "+uiAnimationSets.val);
			} 
			}
		}
		private void AnimationSpeedChanger()
		{
			float speed = VelocityForward*AnimationSpeedMult.val;
			if(speed<.75f){
			speed=.90f;
			}
			Timeline.SetFloatParamValue("Speed walk 1", speed);//+(VelocityForward*AnimationSpeedChanger.val).ToString());
			//Timeline.CallAction("Speed walk 2")=VelocityForward*AnimationSpeedChanger.val;
			//Timeline.CallAction("Speed walk 3")=VelocityForward*AnimationSpeedChanger.val;
		}
			
		
		/* private void TriggerAlignment()
		{
			
		} */
		private void ResetMovement(){
			MoveForward=0;
			MoveBackward=0;
			MoveRight=0;
			MoveLeft=0;
		}
		private void ResetAnimOnces()
		{
			//this is to help keep animations only triggered the one time
			TriggerIdleAnimActionsOnce=0;
			TriggerWalkAnimActionsOnce=0;
			TriggerMoveRightAnimActionsOnce=0;
			TriggerMoveLeftAnimActionsOnce=0;
			TriggerBackAnimActionsOnce=0;
			
		}
		
		private void SetToBasisRun(){
			
			VelocityBackward=0f;
			VelocityForward=0f;
			VelocityRight=0f;
			VelocityLeft=0f;
			var atomControl = _atom.GetStorableByID("control");
			float currentXPosition = transform.position.x;
			float currentYPosition = transform.position.y;
			float currentZPosition = transform.position.z;
			Quaternion currentRotation = transform.rotation;

			// Convert the rotation to Euler angles for easier understanding
			Vector3 eulerRotation = currentRotation.eulerAngles;

			float currentXRotation =  eulerRotation.x;
			float currentYRotation =  eulerRotation.y;
			float currentZRotation =  eulerRotation.z;
		
			atomControl.transform.rotation =  Quaternion.Euler(0f, setModelYRot.val, 0f);
			atomControl.transform.position = new Vector3(setModelX.val,setModelY.val,setModelZ.val);
			
			
		}
		
		private void DebugAlignSubRun(){
			DebugAlign=1;
			velocityforsmoothdamp=0f;
			PastPlayerXPosition=currentXPositionPlayer;
			PastPlayerZPosition=currentZPositionPlayer;
		}
		private void MoveBack(){
		MoveBackward=1;
		}		
		
		private void TestRightRun(){
			MoveRight=1;
			RightTimer=.001f;
		}
		private void TestLeftRun(){
			MoveLeft=1;
			LeftTimer=.001f;
		}
		
		// FixedUpdate is called with each physics simulation frame by Unity
		void FixedUpdate() {
			try {
				/* if (_atom.type == "Person")
					{
						currentXPosition = transform.position.x;
						currentYPosition = transform.position.y;
						currentZPosition = transform.position.z;
						genericAtom=0;
					}
					else
					{
						Transform objectTransform = containingAtom.transform;
						Vector3 localPosition = objectTransform.localPosition;
						currentXPosition = localPosition.x;
						currentYPosition = localPosition.y;
						currentZPosition = localPosition.z;
						genericAtom=1;
					} */
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		//synth subs
		  void MovementInput()
        {
            if (SuperController.singleton.GetSelectedAtom() != containingAtom)
            {
                return;
            }

            if (SuperController.singleton.GetLeftGrabVal()>1f-ControllerTriggerSensitivity.val || SuperController.singleton.GetRightGrabVal()>1f-ControllerTriggerSensitivity.val)
            {
				if(UseLeftController.val==true&&SuperController.singleton.GetLeftGrabVal()>0){
                Transform lineLeft = SuperController.singleton.rayLineLeft.transform;
				SuperController.singleton.rayLineLeft.gameObject.SetActive(true);
				Ray rayLeft = new Ray(lineLeft.transform.position, lineLeft.transform.rotation * Vector3.forward);
                ProcessRay(rayLeft);
				}
				if(UseRightController.val==true&&SuperController.singleton.GetRightGrabVal()>0){
				SuperController.singleton.rayLineRight.gameObject.SetActive(true);
                Transform lineRight = SuperController.singleton.rayLineRight.transform;
                Ray rayRight = new Ray(lineRight.transform.position, lineRight.transform.rotation * Vector3.forward);
                ProcessRay(rayRight);
				}
                //ClearForcePlayAnimation();
            }

            if (Input.GetMouseButtonDown(1))
            {
                ProcessRay(Camera.main.ScreenPointToRay(Input.mousePosition));
               
            }
        }
		void ProcessRay(Ray ray)
        {
            RaycastHit hit;
            if (Physics.Raycast(ray, out hit))
            {
                if (hit.collider.GetType() != typeof(BoxCollider))
                {
                    return;
                }
                groundCollider = hit.collider;
                goal = hit.point;
            }
        }
		Transform CreateMarker(Transform parent)
        {
            var go = GameObject.CreatePrimitive(PrimitiveType.Sphere).transform;
            go.parent = parent;
            go.localScale = new Vector3(.1f, .1f, .1f);
            go.localPosition = Vector3.zero;
            go.localRotation = Quaternion.identity;
            GameObject.Destroy(go.GetComponent<SphereCollider>());
            return go;
        }
		 void SetTargetVisibility(bool visible)
        {
            if (goalMarker == null)
            {
                return;
            }

            goalMarker.gameObject.SetActive(visible);
        }
		void MoveToVector(Vector3 newGoal) {
            goal = newGoal;
            //ClearForcePlayAnimation();
        }

		void OnDestroy() {
			

            if (goalMarker != null)
            {
                GameObject.Destroy(goalMarker.gameObject);
            }
		}
		List<string> GetStorableIDsContainingSubstring(string substring)
		{
			List<string> matchingIDs = new List<string>();

			foreach (string id in storableIDs)
			{
				if (id.Contains(substring))
				{
					matchingIDs.Add(id);
				}
			}

			return matchingIDs;
		}//ty chatgpt
		public static List<float> Logspace(float start, float stop, int num, float @base = 10.0f)
		{
			List<float> result = new List<float>();

			if (num <= 1)
			{
				result.Add(Mathf.Pow(@base, start));
				return result;
			}

			float step = (stop - start) / (num - 1);

			for (int i = 0; i < num; i++)
			{
				float exponent = start + step * i;
				result.Add(Mathf.Pow(@base, exponent));
			}

			return result;
		}
		/* public void SaveJSONStorables(string filePath)
		{
			List<string> jsonStrings = new List<string>();

			foreach (var storable in jsonStorables)
			{
				// Serialize JSONStorable data to JSON
				string jsonString = JsonUtility.ToJson(storable);
				jsonStrings.Add(jsonString);
			}

			// Save JSON strings to a file
			File.WriteAllLines(filePath, jsonStrings.ToArray());
		}
		public void LoadJSONStorables(string filePath)
		{
			if (File.Exists(filePath))
			{
				string[] jsonStrings = File.ReadAllLines(filePath);

				for (int i = 0; i < Mathf.Min(jsonStorables.Count, jsonStrings.Length); i++)
				{
					// Deserialize JSON string to JSONStorable object
					JsonUtility.FromJsonOverwrite(jsonStrings[i], jsonStorables[i]);
				}
			}
			else
			{
				Debug.LogError("File not found: " + filePath);
			}
		}	 */
		
	}
}